diff --git a/test/periphery-lld/INA219_v1/aos_test_INA219.c b/test/periphery-lld/INA219_v1/aos_test_INA219.c
new file mode 100644
index 0000000..c1db278
--- /dev/null
+++ b/test/periphery-lld/INA219_v1/aos_test_INA219.c
@@ -0,0 +1,191 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_INA219.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <math.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+aos_testresult_t aosTestIna219Func(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck(test->data != NULL && ((aos_test_ina219data_t*)(test->data))->inad != NULL);
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  int32_t status;
+  uint16_t data[6];
+  uint16_t write_data = 0x1011;
+  uint16_t new_data[6];
+  uint16_t reset_data;
+  uint16_t test_calib = 0;
+  int16_t usensor_data = 0;
+  uint16_t busready = 0;
+  uint32_t power = 0;
+  int32_t shunt;
+  uint32_t bus;
+
+  chprintf(stream, "read registers...\n");
+  status = ina219_lld_read_register(((aos_test_ina219data_t*)test->data)->inad, INA219_LLD_REGISTER_CONFIGURATION, data, 6, ((aos_test_ina219data_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "write registers...\n");
+  status = ina219_lld_write_register(((aos_test_ina219data_t*)test->data)->inad, INA219_LLD_REGISTER_CONFIGURATION, &write_data, 1, ((aos_test_ina219data_t*)test->data)->timeout);
+  status |= ina219_lld_read_register(((aos_test_ina219data_t*)test->data)->inad, INA219_LLD_REGISTER_CONFIGURATION, new_data, 6, ((aos_test_ina219data_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS && new_data[0] == write_data) {
+    uint8_t errors = 0;
+    for (uint8_t dataIdx = 1; dataIdx < 6; dataIdx++) {
+      if (new_data[dataIdx] != data[dataIdx]) {
+        ++errors;
+      }
+    }
+    if (errors == 0) {
+      aosTestPassed(stream, &result);
+    } else {
+      aosTestFailed(stream, &result);
+    }
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "reset...\n");
+  status = ina219_lld_reset(((aos_test_ina219data_t*)test->data)->inad, ((aos_test_ina219data_t*)test->data)->timeout);
+  status |= ina219_lld_read_register(((aos_test_ina219data_t*)test->data)->inad, INA219_LLD_REGISTER_CONFIGURATION, &reset_data, 1, ((aos_test_ina219data_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS && reset_data == 0x399F) {
+    aosTestPassed(stream, &result);
+  } else {
+    chprintf(stream, "\tfailed\n");
+    ++result.failed;
+  }
+
+  chprintf(stream, "read config...\n");
+  ina219_lld_cfg_t ina_config;
+  status = ina219_lld_read_config(((aos_test_ina219data_t*)test->data)->inad, &ina_config, ((aos_test_ina219data_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "write config...\n");
+  ina_config.data = 0x7FFu;
+  status = ina219_lld_write_config(((aos_test_ina219data_t*)test->data)->inad, ina_config, ((aos_test_ina219data_t*)test->data)->timeout);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+
+  chprintf(stream, "calibrate...\n");
+  ina219_lld_calib_input_t calib_in;
+  calib_in.shunt_resistance_0 = 0.1f;
+  calib_in.max_expected_current_A = 0.075f;
+  calib_in.current_lsb_uA = 10;
+  calib_in.cfg_reg = ina_config;
+  ina219_lld_calib_output_t calib_out;
+  status = ina219_lld_calibration(((aos_test_ina219data_t*)test->data)->inad, &calib_in, &calib_out);
+  status |= ina219_lld_write_calibration(((aos_test_ina219data_t*)test->data)->inad, calib_out.calibration & 0xFFFEu, ((aos_test_ina219data_t*)test->data)->timeout);
+  status |= ina219_lld_write_calibration(((aos_test_ina219data_t*)test->data)->inad, 0xA000, ((aos_test_ina219data_t*)test->data)->timeout);
+  ina219_lld_cfg_t test_config;
+  ((aos_test_ina219data_t*)test->data)->inad->current_lsb_uA = 0xA;
+  status |= ina219_lld_read_config(((aos_test_ina219data_t*)test->data)->inad, &test_config, ((aos_test_ina219data_t*)test->data)->timeout);
+  status |= ina219_lld_read_calibration(((aos_test_ina219data_t*)test->data)->inad, &test_calib, ((aos_test_ina219data_t*)test->data)->timeout);
+  while (!busready || power == 0) {
+    aosThdMSleep(20);
+    status |= ina219_lld_bus_conversion_ready(((aos_test_ina219data_t*)test->data)->inad, &busready, ((aos_test_ina219data_t*)test->data)->timeout);
+    status |= ina219_lld_read_power(((aos_test_ina219data_t*)test->data)->inad, &power, ((aos_test_ina219data_t*)test->data)->timeout);
+  }
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read shunt voltage...\n");
+  status = ina219_lld_read_shunt_voltage(((aos_test_ina219data_t*)test->data)->inad, &shunt, ((aos_test_ina219data_t*)test->data)->timeout);
+  chprintf(stream, "\t\tshunt voltage: %fV\n", (float)shunt/1000000.f);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read bus voltage (%u%% tolerance)...\n", (uint8_t)(((aos_test_ina219data_t*)test->data)->tolerance * 100.f + 0.5f));
+  status = ina219_lld_read_bus_voltage(((aos_test_ina219data_t*)test->data)->inad, &bus, ((aos_test_ina219data_t*)test->data)->timeout);
+  chprintf(stream, "\t\tbus voltage: %fV\n", (float)bus/1000000.f);
+  if ((status == APAL_STATUS_SUCCESS) && (fabs(((float)bus/1000000.f) - ((aos_test_ina219data_t*)test->data)->v_expected) < ((aos_test_ina219data_t*)test->data)->v_expected * ((aos_test_ina219data_t*)test->data)->tolerance)) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read power...\n");
+  status = ina219_lld_read_power(((aos_test_ina219data_t*)test->data)->inad, &power, ((aos_test_ina219data_t*)test->data)->timeout);
+  chprintf(stream, "\t\tpower: %fW\n", (float)(power)/1000000.f);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read current...\n");
+  status = ina219_lld_read_current(((aos_test_ina219data_t*)test->data)->inad, &usensor_data, ((aos_test_ina219data_t*)test->data)->timeout);
+  chprintf(stream, "\t\tcurrent: %fA\n", (float)(usensor_data)/1000000.f);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  aosTestInfoMsg(stream, "driver object memory footprint: %u bytes\n", sizeof(INA219Driver));
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
diff --git a/test/periphery-lld/INA219_v1/aos_test_INA219.h b/test/periphery-lld/INA219_v1/aos_test_INA219.h
new file mode 100644
index 0000000..9b7dab0
--- /dev/null
+++ b/test/periphery-lld/INA219_v1/aos_test_INA219.h
@@ -0,0 +1,91 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_INA219_H
+#define AMIROOS_TEST_INA219_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_INA219.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   INA219 driver to use.
+   */
+  INA219Driver *inad;
+
+  /**
+   * @brief   Expected voltage to be measured.
+   */
+  float v_expected;
+
+  /**
+   * @brief   Tolerance (relative) of measurement.
+   */
+  float tolerance;
+
+  /**
+   * @brief   Timeout delay for certain tests.
+   */
+  apalTime_t timeout;
+} aos_test_ina219data_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestIna219Func(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_INA219_H */
diff --git a/test/periphery-lld/L3G4200D_v1/aos_test_L3G4200D.c b/test/periphery-lld/L3G4200D_v1/aos_test_L3G4200D.c
new file mode 100644
index 0000000..d1788f3
--- /dev/null
+++ b/test/periphery-lld/L3G4200D_v1/aos_test_L3G4200D.c
@@ -0,0 +1,288 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+#include <aos_test_L3G4200D.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+/**
+ * @brief   L3G4200D test function.
+ *
+ * @param[in] stream  Stream for input/output.
+ * @param[in] test    Test object.
+ *
+ * @return            Test result value.
+ */
+aos_testresult_t aosTestL3g4200dFunc(BaseSequentialStream* stream, const aos_test_t* test)
+{
+  aosDbgCheck(test->data != NULL && ((aos_test_l3g4200ddata_t*)(test->data)) != NULL);
+
+  // local variables
+  aos_testresult_t result = {0, 0};
+  uint32_t status;
+  uint8_t data = 0;
+  uint8_t write_data[5];
+  uint8_t read_data[5];
+  int16_t sdata[3];
+  uint8_t status_reg;
+  eventmask_t event_mask;
+  bool success = false;
+  uint8_t fifo = 0x5F;
+  event_listener_t el;
+
+  for (uint8_t dataIdx = 0; dataIdx < 4; dataIdx++) {
+    write_data[dataIdx] = (dataIdx+1)*11;
+  }
+  write_data[4] = 0;
+
+  chprintf(stream, "check identity...\n");
+  status = l3g4200d_lld_read_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, L3G4200D_LLD_REGISTER_WHO_AM_I, &data, 1);
+  if(status == APAL_STATUS_SUCCESS && data == L3G4200D_LLD_WHO_AM_I){
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X, data: %d\n", status, data);
+  }
+
+  chprintf(stream, "write register...\n");
+  status = l3g4200d_lld_write_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, L3G4200D_LLD_REGISTER_CTRL_REG1, write_data, 1);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read register...\n");
+  status = l3g4200d_lld_read_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, L3G4200D_LLD_REGISTER_CTRL_REG1, &data, 1);
+  if (status == APAL_STATUS_SUCCESS && data == write_data[0]) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailedMsg(stream, &result, "0x%08X, data: %d\n", status, data);
+  }
+
+  chprintf(stream, "write multiple registers...\n");
+  status = l3g4200d_lld_write_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, L3G4200D_LLD_REGISTER_CTRL_REG1, write_data, 5);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read multiple registers...\n");
+  status = l3g4200d_lld_read_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, L3G4200D_LLD_REGISTER_CTRL_REG1, read_data, 5);
+  uint8_t errors = 0;
+  for (uint8_t dataIdx = 0; dataIdx < 5; dataIdx++) {
+    if (read_data[dataIdx] != write_data[dataIdx]) {
+      ++errors;
+    }
+  }
+  if (status == APAL_STATUS_SUCCESS && errors == 0) {
+    aosTestPassed(stream, &result);
+  } else {
+    for (uint8_t dataIdx = 0; dataIdx < 5; dataIdx++) {
+      chprintf(stream, "\t\tStatus: %d, CTRL_REG%d: %d, write_data: %d\n", status, dataIdx+1, read_data[dataIdx], write_data[dataIdx]);
+    }
+    aosTestFailedMsg(stream, &result, "0x%08X, errors: %d\n", status, errors);
+  }
+
+  chprintf(stream, "read config...\n");
+  l3g4200d_lld_cfg_t cfg;
+  status = l3g4200d_lld_read_config(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, &cfg);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "write config...\n");
+  cfg.registers.ctrl_reg1 = L3G4200D_LLD_PD | L3G4200D_LLD_DR_100_HZ | L3G4200D_LLD_BW_12_5 | L3G4200D_LLD_ZEN | L3G4200D_LLD_YEN | L3G4200D_LLD_XEN;
+  //cfg.registers.ctrl_reg1 = L3G4200D_LLD_PD | L3G4200D_LLD_DR_800_HZ | L3G4200D_LLD_BW_20 | L3G4200D_LLD_ZEN | L3G4200D_LLD_YEN | L3G4200D_LLD_XEN;
+  cfg.registers.ctrl_reg3 = 0x07;
+  cfg.registers.ctrl_reg5 |= L3G4200D_LLD_FIFO_EN;
+  status = l3g4200d_lld_write_config(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, cfg);
+  uint8_t reg1 = cfg.data[0];
+  status |= l3g4200d_lld_read_config(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, &cfg);
+  if (status == APAL_STATUS_SUCCESS && cfg.data[0] == reg1) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read gyro data for five seconds...\n");
+  status = APAL_STATUS_OK;
+  for (uint8_t i = 0; i < 5; ++i) {
+    status |= l3g4200d_lld_read_all_data(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, sdata, &cfg);
+    chprintf(stream, "\t\tX = %6d\tY = %6d\tZ = %6d\n", sdata[0], sdata[1], sdata[2]);
+    aosThdSSleep(1);
+  }
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read X axis for five seconds...\n");
+  status = APAL_STATUS_SUCCESS;
+  for (uint32_t i = 0; i <= 5; i++) {
+    status |= l3g4200d_lld_read_data(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, &(sdata[0]), L3G4200D_LLD_X_AXIS, &cfg);
+    chprintf(stream, "\t\tX = %6d\n", sdata[0]);
+    aosThdSSleep(1);
+  }
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read Y axis for five seconds...\n");
+  status = APAL_STATUS_SUCCESS;
+  for (uint32_t i = 0; i <= 5; i++) {
+    status |= l3g4200d_lld_read_data(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, &(sdata[0]), L3G4200D_LLD_Y_AXIS, &cfg);
+    chprintf(stream, "\t\tY = %6d\n", sdata[0]);
+    aosThdSSleep(1);
+  }
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read Z axis for five seconds...\n");
+  status = APAL_STATUS_SUCCESS;
+  for (uint32_t i = 0; i <= 5; i++) {
+    status |= l3g4200d_lld_read_data(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, &(sdata[0]), L3G4200D_LLD_Z_AXIS, &cfg);
+    chprintf(stream, "\t\tZ = %6d\n", sdata[0]);
+    aosThdSSleep(1);
+  }
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+  aosThdMSleep(10);
+
+  chprintf(stream, "read status register...\n");
+  status = l3g4200d_lld_read_status_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, &status_reg);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "read interrupt config...\n");
+  l3g4200d_lld_int_cfg_t int_cfg;
+  status = l3g4200d_lld_read_int_config(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, &int_cfg);
+  if (status == APAL_STATUS_SUCCESS) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "write interrupt config...\n");
+  int_cfg.registers.int1_tsh_xh = 10;
+  status = l3g4200d_lld_write_int_config(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, int_cfg);
+  l3g4200d_lld_int_cfg_t int_cfg2;
+  status |= l3g4200d_lld_read_int_config(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, &int_cfg2);
+  if (status == APAL_STATUS_SUCCESS && int_cfg.registers.int1_tsh_xh == 10) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chprintf(stream, "interrupt test: read fifo until empty...\n");
+  chEvtRegister(((aos_test_l3g4200ddata_t*)(test->data))->src, &el, 0);
+  status = l3g4200d_lld_write_fifo_ctrl_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd,fifo);
+  fifo = 0;
+  status |= l3g4200d_lld_read_fifo_ctrl_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd,&fifo);
+  status |= l3g4200d_lld_read_all_data(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, sdata, &cfg);
+  chEvtGetAndClearFlags(&el);
+  aosThdSSleep(1);
+  chEvtGetAndClearFlags(&el);
+  success = false;
+  for (uint8_t i = 0; i < 200; i++) {
+    status |= l3g4200d_lld_read_all_data(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, sdata, &cfg);
+    event_mask = chEvtWaitAnyTimeout(~0, TIME_IMMEDIATE);
+    status |= l3g4200d_lld_read_fifo_src_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd,&fifo);
+    if (event_mask != 0 && ((fifo & L3G4200D_LLD_EMPTY) || fifo == 0)) {
+      success = true;
+      break;
+    }
+    aosThdMSleep(1);
+  }
+  if (status == APAL_STATUS_SUCCESS && success) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  fifo = 0x4A;
+  status |= l3g4200d_lld_write_fifo_ctrl_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd,fifo);
+  cfg.registers.ctrl_reg1 = L3G4200D_LLD_PD | L3G4200D_LLD_DR_800_HZ | L3G4200D_LLD_BW_20 | L3G4200D_LLD_ZEN | L3G4200D_LLD_YEN | L3G4200D_LLD_XEN;
+  cfg.registers.ctrl_reg3 = 0x04;
+  status |= l3g4200d_lld_write_config(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, cfg);
+  chprintf(stream, "interrupt test: wait until wtm reached...\n");
+  for (uint8_t i = 0; i < 200; i++) {
+    status |= l3g4200d_lld_read_all_data(((aos_test_l3g4200ddata_t*)(test->data))->l3gd, sdata, &cfg);
+    event_mask = chEvtWaitAnyTimeout(~0, TIME_IMMEDIATE);
+    status |= l3g4200d_lld_read_fifo_src_register(((aos_test_l3g4200ddata_t*)(test->data))->l3gd,&fifo);
+    if (event_mask != 0 && (fifo & L3G4200D_LLD_WTM)) {
+      success = true;
+      break;
+    }
+    aosThdMSleep(10);
+  }
+  if (status == APAL_STATUS_SUCCESS && success) {
+    aosTestPassed(stream, &result);
+  } else {
+    aosTestFailed(stream, &result);
+  }
+
+  chEvtUnregister(((aos_test_l3g4200ddata_t*)(test->data))->src, &el);
+  aosThdMSleep(10);
+
+  aosTestInfoMsg(stream, "driver object memory footprint: %u bytes\n", sizeof(L3G4200DDriver));
+
+  return result;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
diff --git a/test/periphery-lld/L3G4200D_v1/aos_test_L3G4200D.h b/test/periphery-lld/L3G4200D_v1/aos_test_L3G4200D.h
new file mode 100644
index 0000000..d33a4c4
--- /dev/null
+++ b/test/periphery-lld/L3G4200D_v1/aos_test_L3G4200D.h
@@ -0,0 +1,91 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#ifndef AMIROOS_TEST_L3G4200D_H
+#define AMIROOS_TEST_L3G4200D_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <alld_L3G4200D.h>
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/**
+ * @brief   Custom data structure for the test.
+ */
+typedef struct {
+  /**
+   * @brief   L3G4200D driver to use.
+   */
+  L3G4200DDriver *l3gd;
+
+  /**
+   * @brief   SPI configuratoin.
+   */
+  SPIConfig *spiconf;
+
+  /**
+   * @brief   Event source for certain tests.
+   */
+  event_source_t *src;
+
+  /**
+   * @brief   Event flags to watch.
+   */
+  eventflags_t evtflags;
+} aos_test_l3g4200ddata_t;
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  aos_testresult_t aosTestL3g4200dFunc(BaseSequentialStream* stream, const aos_test_t* test);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* AMIROOS_TEST_L3G4200D_H */
